# Additional DP Optimizations and Techniques

Author: Andi Qu

Additional dynamic programming techniques and optimizations like Knuth's optimization.

## Knuth's Optimization

### Tutorials

Resources | ||||
---|---|---|---|---|

Jeffrey Xiao | ||||

GCP | ||||

GFG | Good explanation + Proof of correctness |

Knuth's optimization is a special case of Range DP. In general, it is used to solve DP problems with transitions of the form

Further, the cost function must satisfy the following conditions for all $a\leq b\leq c \leq d$:

- $\texttt{cost}[b][c] \leq \texttt{cost}[a][d]$
- $\texttt{cost}[a][c] + \texttt{cost}[b][d] \leq \texttt{cost}[a][d] + \texttt{cost}[b][c]$ (the quadrangle inequality)

Define $\texttt{opt}[i][j]$ be the index for which $\texttt{dp}[i][k] + \texttt{dp}[k+1][j]$ takes on its minimum value, or equivalently,

If more than one such index exists, then take the minimum (or the maximum, doesn't matter). Then, assuming conditions on the dp transition and the cost function to be satisfied, we can show that $\texttt{opt}$ satisfies

The proof of correctness for this claim is in the resources above.

The structure of the code is identical to that of Range DP, with the exception of maintaining the $\texttt{opt}$ array. To calculate $\texttt{dp}[i][j]$ and $\texttt{opt}[i][j]$, it is only necessary to check values of $k$ between $\texttt{opt}[i][j-1]$ and $\texttt{opt}[i+1][j]$. Because of the momotonicity of $\texttt{opt}$, the time complexity of the final algorithm can be shown to be $\mathcal{O}(N^2)$.

### Knuth's Optimization Problems

Status | Source | Problem Name | Difficulty | Tags | |
---|---|---|---|---|---|

CF | Easy | ||||

SPOJ | Normal | ||||

onlinejudge.org | Normal | ||||

onlinejudge.org | Hard |

## Connected-Component DP

Resources | ||||
---|---|---|---|---|

CF | Miscellaneous techniques |

### Connected-Component DP Problems

### This section is not complete.

Make Permutations II a focus problem, move analysis to module.

Status | Source | Problem Name | Difficulty | Tags | |
---|---|---|---|---|---|

CSES | Easy | ||||

CF | Easy | ||||

CEOI | Normal | ||||

CF | Normal | ||||

JOI | Normal | ||||

CF | Normal |

## DP on Broken Profile

Broken profile DP is a subset of bitmask DP. Problems falling under this category generally have the following properties:

- They're about filling a 2D grid.
- One of the dimensions is much smaller than the other.
- When filling the grid, each cell depends only on adjacent cells.
- The cells don't have many possible values (usually only 2).

The third property is especially important, as it means that we can process the cells column-by-column (imagine a snake wrapping around the grid). We then only need to care about the rightmost processed cell in each row (hence the name "broken profile").

The fourth property suggests that we should use a bitmask to represent that broken profile.

### Warning!

Note that the bitmask doesn't necessarily have to represent the state of the
*cells*. In some problems (e.g. CEOI 2006 Connect), it can represent the state
of the cell *borders* instead.

Focus Problem – try your best to solve this problem before continuing!

### Tutorial

We'll process the grid cells column-by-column, row-by-row. Let $i$ and $j$ denote the row and column of the current cell we are considering, and $\texttt{dp}[i][j][mask]$ be the number of ways to tile the grid so that:

- All cells from cell $(0, 0)$ to cell $(i, j - 1)$ are
**covered**. - All cells from cell $(i + 1, j)$ to cell $(N - 1, M - 1)$ are
**empty**. - $mask$ represents whether each of the remaining $N$ cells are
**empty**, with the $k$-th bit corresponding to the cell in row $k$.

For example, the following state would contribute toward $\texttt{dp}[1][3][00101_2]$:

The answer will be $\texttt{dp}[N - 1][M - 1][0]$.

We now have three cases when calculating $\texttt{dp}[i][j][mask]$:

- The $i$-th bit of the mask is 0, meaning that cell $(i, j)$ is
**covered**.- Case 1: we used a horizontal tile to cover it.
- Cell $(i, j - 1)$ must have been empty, so there are $\texttt{dp}[i - 1][j][mask \oplus 2^i]$ ways to do this.

- Case 2: we used a vertical tile to cover it.
- This is only possible if $i > 0$.
- Cell $(i,j-1)$ must have been covered and cell $(i-1,j)$ must have been empty, so there are $\texttt{dp}[i - 1][j][mask \oplus 2^{i - 1}]$ ways to do this.
- This corresponds to
`if (i && !(mask & (1 << i)) && !(mask & (1 << i - 1)))`

in the code below.

- The $i$-th bit of the mask is 1, meaning that cell $(i, j)$ is
**empty**.- Cell $(i, j - 1)$ must have been covered, so there are $\texttt{dp}[i - 1][j][mask \oplus 2^i]$ ways to do this.
- This is the same as case 1 of when the $i$-th bit of the mask is 0, so we handle them simultaneously in the code below.

Note that the indices we need to use may become negative and will thus require wrapping. To simplify calculations and bypass this, simply drop the first two dimensions of the DP array, as $\texttt{dp}[i][j]$ depends only on $\texttt{dp}[i - 1][j]$.

### Code

**Time Complexity:** $\mathcal O(NM 2^N)$

C++

#include <bits/stdc++.h>using namespace std;const int MOD = 1e9 + 7;int dp[1 << 10][2];int main() {int n, m;cin >> n >> m;

### Broken profile DP Problems

Status | Source | Problem Name | Difficulty | Tags | |
---|---|---|---|---|---|

CF | Normal | ## Show TagsBroken Profile | |||

COCI | Normal | ## Show TagsBroken Profile | |||

CEOI | Hard | ||||

Platinum | Very Hard | ## Show TagsBroken Profile |

### Module Progress:

### Join the USACO Forum!

Stuck on a problem, or don't understand a module? Join the USACO Forum and get help from other competitive programmers!